#pragma once

#include <vector>
#include <cassert>

template<class super>
class buffer : public super
{
    class buffer_impl
    {
        std::vector<char> m_buffer;
        size_t m_head_offset;
        size_t m_len;

      public:
        buffer_impl()
            : m_buffer(2000),
              m_head_offset(100),
              m_len(0)
        {}

        void reset()
        {
            m_head_offset = 100;
            m_len = 0;
        }

        char *head()
        {
            return &m_buffer[0] + m_head_offset;
        }

        void head_add(size_t size)
        {
            assert(size < m_head_offset);

            m_head_offset -= size;
            m_len += size;
        }

        void head_del(size_t size)
        {
            assert(size < m_buffer.size() - m_head_offset);

            m_head_offset += size;
            m_len -= size;
        }

        size_t len() const
        {
            return m_len;
        }

        void len_add(size_t size)
        {
            assert(size < m_buffer.size() - m_head_offset);

            m_len += size;
        }

        size_t len_max() const
        {
            return m_buffer.size() - m_head_offset;
        }
    };

  public:
    typedef buffer_impl buffer_type;
};
