#pragma once

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <endian.h>

#include <system_error>

template<class super>
class sock_udp : public super
{
    typedef typename super::buffer_type buffer;

    int m_sock;
    struct sockaddr_in m_sin = {0};
    struct sockaddr *m_sa = reinterpret_cast<struct sockaddr *>(&m_sin);

    void open_socket()
    {

        if ((m_sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
            throw std::system_error(errno, std::system_category(),
                                    "unable to open socket");

        m_sin.sin_family = AF_INET;
        m_sin.sin_addr.s_addr = inet_addr("127.0.0.1");
        m_sin.sin_port = htobe16(6677);

        if (bind(m_sock, m_sa, sizeof(m_sin)) < 0)
            //throw std::system_error(errno, std::system_category(),
            //                        "unable to bind to port");
            ;
    }

  public:
    sock_udp()
        : super()
    {
        open_socket();
    }

    bool send_buf(buffer &buf)
    {
        int ret;

        ret = sendto(m_sock, buf.head(), buf.len(), 0, m_sa, sizeof(m_sin));

        return ret == buf.len();
    }

    bool recv_buf(buffer &buf)
    {
        int ret;

        ret = recvfrom(m_sock, buf.head(), buf.len_max(), 0, NULL, NULL);

        if (ret < 0)
            throw std::system_error(errno, std::system_category(),
                                    "unable to recv on socket");

        buf.len_add(ret);

        return true;
    }
};
